/* Instituto Federal de Santa Catarina Campus São José - IFSC-SJ
 %  Curso Superior de Tecnologia em Sistema de Telecomunicações
 %  Programação Orientada a Objetos - POO 2014.2
 %  Professor: Tulio Alberton Ribeiro
 %  Prova II - Socket
 %  Aluno: Jânio Anselmo
 %  Original por: Oracle and/or its affiliates. All rights reserve, 2013
 %  Alterado por: Jânio Anselmo
 %  29.10.2014 09:40 -- Última alteração
 %  por: Jânio Anselmo -- janioanselmo@hotmail.com.br
 %  Arquivo: EchoServer.java
 %  */

package JanioAnselmo;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.lang.*;

public class EchoServer {

    private static String arquivo = "meusDados.txt";

    public static void main(String[] args) throws IOException {

        TrataComandos eco = new TrataComandos();

        if (args.length != 1) {
            System.err.println("Usage: java EchoServer <port number>");
            System.exit(1);
        }

        int portNumber = Integer.parseInt(args[0]);

        try {

            //cria ligação host e porta. Fica escutando a porta xxx
            ServerSocket serverSocket
                    = new ServerSocket(Integer.parseInt(args[0]));
            System.out.println("Servidor iniciado na porta: " + portNumber);
            //espera pela conexão com cliente.
            Socket clientSocket = serverSocket.accept();
            System.out.println("Cliente conectado: " + clientSocket.getInetAddress());

            //canal de comunicação para saída de dados. Lembrar OUTPUT
            PrintWriter out
                    = new PrintWriter(clientSocket.getOutputStream(), true);

            //canal de comunicação para entrada de dados. Lembrar INPUT
            BufferedReader in = new BufferedReader(
                    new InputStreamReader(clientSocket.getInputStream()));

            String inputLine;
            String[] buffer = new String[4];
            int i = 0;

            while ((inputLine = in.readLine()) != null) {
                //out.println(inputLine);
                // trata palavras reservadas
                if (!inputLine.equalsIgnoreCase("quit")
                        && !inputLine.equalsIgnoreCase("exit")
                        && !inputLine.equalsIgnoreCase("saveData")
                        && !inputLine.equalsIgnoreCase("cleanData")
                        && !inputLine.equalsIgnoreCase("showData")) {
                    buffer[i++] = inputLine.toString();
                    System.out.println("Bufferizando: \"" + inputLine.toString() + "\"");
                }

                if (i >= 4 || inputLine.equalsIgnoreCase("saveData")) {
                    for (int x = 0; x < buffer.length; x++) {
                        if (buffer[x] != null) {
                            eco.salvaDadoNoDisco(buffer[x], arquivo);
                            out.println("Salvando: " + buffer[x]);
                        }
                    }
                    //necessário para limpar o buffer.
                    //pode ser feito de outra forma...
                    buffer = new String[4];
                    // para não estourar o buffer, volta-se a 0
                    i = 0;
                }

                if (inputLine.equalsIgnoreCase("showData")) {
                    // o método mostraDadoDoDisco retorna uma StringBuffer
                    // e envia pelo diretamente pelo canal de comunicação.
                    out.println("" + eco.getDadoDoDisco(arquivo));
                }
                if (inputLine.equalsIgnoreCase("cleanData")) {
                    //a ideia por trás é simples, é o mesmo método saveData,
                    // só que com o parâmetro que define concatenar ou refazer o 
                    //arquivo está setado para false. 
                    //E quando vai salvar, salva-se vazio.
                    eco.cleanData("meusDados.txt");
                }
                if (inputLine.equalsIgnoreCase("exit")
                        || inputLine.equalsIgnoreCase("quit")) {
                    //tratamento para término do servidor.
                    System.exit(0);
                } else {
                    //tratamento do comando.
                    String delimiter = " ";
                    String[] StringCommand = inputLine.split(delimiter);
                    eco.separaCommando(StringCommand);
                }

            }
        } catch (IOException e) {
            System.out.println("Exception caught when trying to listen on port "
                    + portNumber + " or listening for a connection");
            System.out.println(e.getMessage());
        }
    }
}
