package PossivelSolucao;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;


//Como vamos mudar os métodos de classe, devemos por limpeza de código 
//remover os imports não utilizados e importar a nova.
import PossivelSolucao.Uteis;

public class EchoServer {

    private static String arquivo = "meusDados.txt";
    private static Uteis util = new Uteis();

    public static void main(String[] args) throws IOException {

        if (args.length != 1) {
            System.err.println("Usage: java EchoServer <port number>");
            System.exit(1);
        }

        int portNumber = Integer.parseInt(args[0]);

        try {

            //cria ligação host e porta. Fica escutando a porta xxx
            ServerSocket serverSocket
                    = new ServerSocket(Integer.parseInt(args[0]));
            System.out.println("Servidor iniciado na porta: " + portNumber);
            //espera pela conexão com cliente.
            Socket clientSocket = serverSocket.accept();
            System.out.println("Cliente conectado: " + clientSocket.getInetAddress());

            //canal de comunicação para saída de dados. Lembrar OUTPUT
            PrintWriter canalSaida
                    = new PrintWriter(clientSocket.getOutputStream(), true);

            //canal de comunicação para entrada de dados. Lembrar INPUT
            BufferedReader in = new BufferedReader(
                    new InputStreamReader(clientSocket.getInputStream()));

            String inputLine;
            String[] buffer = new String[4];
            int i = 0;
            
            //Criarei um vetor para armazenar meu novo modelo de comandos. 
            String [] cmd;
            //não definirei tamanho, a função .split() definirá.
            

            while ((inputLine = in.readLine()) != null) {
                
                // O tratamento do novo comando pode ser feito em paralelo 
                // com os comandos antigos. 
                //Devemos escolher tratá-los antes para que possamos 
                //não armazenar em buffer o comando duplicar.
                cmd = inputLine.split(" ");
                
                
                //out.println(inputLine);
                // trata palavras reservadas
                if (!inputLine.equalsIgnoreCase("quit")
                        && !inputLine.equalsIgnoreCase("exit")
                        && !inputLine.equalsIgnoreCase("saveData")
                        && !inputLine.equalsIgnoreCase("cleanData")
                        && !inputLine.equalsIgnoreCase("showData")
                        && !cmd[0].equalsIgnoreCase("duplicar")
                        ) {
                    buffer[i++] = inputLine.toString();
                    System.out.println("Bufferizando: \"" + inputLine.toString() + "\"");
                }

                
                
                //os comandos por convenção sempre cairão na posição [0] do 
                //meu vetor, as posições na sequência são os parâmetros.
                if(cmd[0].equalsIgnoreCase("duplicar")){
                    if(util.duplicarArquivo(cmd[1], cmd[2])){
                        canalSaida.println("Copiado com sucesso, De: "+cmd[1]+
                                " Para: "+cmd[2]);
                    }
                    StringBuffer copia =  util.getDadoDoDisco(cmd[2]);
                    canalSaida.println(""+ copia);
                }
                
                
                
                
                if (i >= 4 || inputLine.equalsIgnoreCase("saveData")) {
                    for (int x = 0; x < buffer.length; x++) {
                        if (buffer[x] != null) {
                            util.salvaDadoNoDisco(buffer[x], arquivo);
                            canalSaida.println("Salvando: " + buffer[x]);
                        }
                    }
                   //necessário para limpar o buffer.
                    //pode ser feito de outra forma...
                    buffer = new String[4];
                    // para não estourar o buffer, volta-se a 0
                    i = 0;
                }

                if (inputLine.equalsIgnoreCase("showData")) {
                   // o método mostraDadoDoDisco retorna uma StringBuffer
                    // e envia pelo diretamente pelo canal de comunicação.
                    canalSaida.println("" + util.getDadoDoDisco(arquivo));
                }
                if (inputLine.equalsIgnoreCase("cleanData")) {
                   //a ideia por trás é simples, é o mesmo método saveData,
                    // só que com o parâmetro que define concatenar ou refazer o 
                    //arquivo está setado para false. 
                    //E quando vai salvar, salva-se vazio.
                    util.cleanData("meusDados.txt");
                }
                if (inputLine.equalsIgnoreCase("exit")
                        || inputLine.equalsIgnoreCase("quit")) {
                    //tratamento para término do servidor.
                    System.exit(0);
                }

            }
        } catch (IOException e) {
            System.out.println("Exception caught when trying to listen on port "
                    + portNumber + " or listening for a connection");
            System.out.println(e.getMessage());
        }
    }


}
