//package prova;

package RamonAlves;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;


public class EchoServer {
    
    private static final String arquivo = "meusDados.txt";
    
    
    public static void main(String[] args) throws IOException {
        
        if (args.length != 1) {
            System.err.println("Usage: java EchoServer <port number>");
            System.exit(1);
        }
        
        int portNumber = Integer.parseInt(args[0]);
        
        try {
            
            //cria ligação host e porta. Fica escutando a porta xxx
            ServerSocket serverSocket =
                new ServerSocket(Integer.parseInt(args[0]));
            System.out.println("Servidor iniciado na porta: "+ portNumber);
            //espera pela conexão com cliente.
            Socket clientSocket = serverSocket.accept();     
            System.out.println("Cliente conectado: "+clientSocket.getInetAddress());
            
            //canal de comunicação para saída de dados. Lembrar OUTPUT
            PrintWriter out =
                new PrintWriter(clientSocket.getOutputStream(), true);                   
            
            //canal de comunicação para entrada de dados. Lembrar INPUT
            BufferedReader in = new BufferedReader(
                new InputStreamReader(clientSocket.getInputStream()));           
            
            String inputLine;
            String [] buffer = new String[4];
            int i=0;
            
            while ((inputLine = in.readLine()) != null) {
                //out.println(inputLine);
               // trata palavras reservadas
                if(!inputLine.equalsIgnoreCase("quit") &&
                       !inputLine.equalsIgnoreCase("exit") &&
                       !inputLine.equalsIgnoreCase("saveData") &&                       
                       !inputLine.equalsIgnoreCase("cleanData") &&
                       !inputLine.equalsIgnoreCase("showData") ){
                    buffer[i++] = inputLine.toString();
                    System.out.println("Bufferizando: \""+inputLine.toString()+ "\"");
                }
                
               if(i>=4 || inputLine.equalsIgnoreCase("saveData")){
                    for (String buffer1 : buffer) {
                        if (buffer1 != null) {
                            salvaDadoNoDisco(buffer1, arquivo);
                            out.println("Salvando: " + buffer1);
                        }
                    }                   
                   //necessário para limpar o buffer.
                   //pode ser feito de outra forma...
                   buffer = new String[4];
                   // para não estourar o buffer, volta-se a 0
                   i=0;
               }
               
               if(inputLine.equalsIgnoreCase("showData")){
                   // o método mostraDadoDoDisco retorna uma StringBuffer
                   // e envia pelo diretamente pelo canal de comunicação.
                   out.println(""+getDadoDoDisco(arquivo));
               }
               if(inputLine.equalsIgnoreCase("cleanData")){
                   //a ideia por trás é simples, é o mesmo método saveData,
                   // só que com o parâmetro que define concatenar ou refazer o 
                   //arquivo está setado para false. 
                   //E quando vai salvar, salva-se vazio.
                   cleanData("meusDados.txt");
               }
               if(inputLine.equalsIgnoreCase("exit") || 
                  inputLine.equalsIgnoreCase("quit")){
                   //tratamento para término do servidor.
                   System.exit(0);
               }
               
            }
        } catch (IOException e) {
            System.out.println("Exception caught when trying to listen on port "
                + portNumber + " or listening for a connection");
            System.out.println(e.getMessage());
        }
    }

    private static boolean salvaDadoNoDisco(String inputLine, String file) {
        try {
            OutputStream os = new FileOutputStream(file, true);
            OutputStreamWriter osw = new OutputStreamWriter(os);
            try (BufferedWriter bw = new BufferedWriter(osw)) {
                bw.write("\n" + inputLine.toString());
            }
            return true;
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
            return false;
        }

    }
    
    private static boolean cleanData(String file) {
        try {
            OutputStream os = new FileOutputStream(file, false);
            OutputStreamWriter osw = new OutputStreamWriter(os);
            BufferedWriter bw = new BufferedWriter(osw);
            //bw.write();
            bw.close();
            return true;
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
            return false;
        }

    }
    
    private static StringBuffer getDadoDoDisco(String file) {
        StringBuffer sb = new StringBuffer();
        try {
            InputStream is = new FileInputStream(file);
            InputStreamReader isr = new InputStreamReader(is);
            try (BufferedReader br = new BufferedReader(isr)) {
                String s = br.readLine();
                sb.append("\n#############################");
                while (s != null) {
                    StringBuffer append = sb.append(s).append("\n");
                    s = br.readLine();
                }
            }
            sb.append("#############################\n");
            return sb;
        }catch(java.io.FileNotFoundException FNE){
            System.err.println("Arquivos não encontrado!");
        }
        catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
        }
        return sb;        
    }
}
