/* Instituto Federal de Santa Catarina Campus São José - IFSC-SJ
 %  Curso Superior de Tecnologia em Sistema de Telecomunicações
 %  Programação Orientada a Objetos - POO 2014.2
 %  Professor: Tulio Alberton Ribeiro
 %  Prova II - Socket
 %  Aluno: Jânio Anselmo
 %  Original por: Oracle and/or its affiliates. All rights reserve, 2013
 %  Alterado por: Jânio Anselmo
 %  29.10.2014 09:40 -- Última alteração
 %  por: Jânio Anselmo -- janioanselmo@hotmail.com.br
 %  Arquivo: TrataComandos.java
 %  */

import java.io.*;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;

public class TrataComandos {

    private static String arquivoCopia = "copiaMeusDados.txt";

    public static boolean salvaDadoNoDisco(String inputLine, String file) {
        try {
            OutputStream os = new FileOutputStream(file, true);
            OutputStreamWriter osw = new OutputStreamWriter(os);
            BufferedWriter bw = new BufferedWriter(osw);
            bw.write("\n" + inputLine);
            bw.close();
            return true;
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
            return false;
        }
    }

    public static boolean cleanData(String file) {
        try {
            OutputStream os = new FileOutputStream(file, false);
            OutputStreamWriter osw = new OutputStreamWriter(os);
            BufferedWriter bw = new BufferedWriter(osw);
            //bw.write();
            bw.close();
            return true;
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
            return false;
        }

    }

    public static StringBuffer getDadoDoDisco(String file) {
        StringBuffer sb = new StringBuffer();
        try {
            InputStream is = new FileInputStream(file);
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            String s = br.readLine();
            sb.append("\n#############################");
            while (s != null) {
                sb.append(s + "\n");
                s = br.readLine();
            }
            br.close();
            sb.append("#############################\n");
            return sb;
        } catch (java.io.FileNotFoundException FNE) {
            System.err.println("Arquivos não encontrado!");
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
        }
        return sb;
    }

    public static StringBuffer salvaDadoNoDiscoCopia(String fileAtual, String fileNovo) {
        StringBuffer sb = new StringBuffer();
        try {
            InputStream is = new FileInputStream(fileAtual);
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            String s = br.readLine();
            sb.append("\n#############################");
            while (s != null) {
                sb.append(s + "\n");
                s = br.readLine();
                salvaDadoNoDisco(s, fileNovo);
            }
            br.close();
            sb.append("#############################\n");
            return sb;
        } catch (java.io.FileNotFoundException FNE) {
            System.err.println("Arquivos não encontrado!");
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
        }
        return sb;
    }

    public static void separaCommando(String[] vectorCommand) {
        //confirma o recebimento da classe "EchoServer" impŕimindo
        // o conteudo das posições do "vectorCommand".
        for (int i = 0; i < vectorCommand.length; i++) {
            System.out.println(vectorCommand[i]);
        }
        String comando = vectorCommand[0];
        String arquivoAtual = vectorCommand[1];
        arquivoCopia = vectorCommand[2];
        //confirma a impressão do arquivo "meusDados.txt" no terminal.
        System.out.println("" + getDadoDoDisco(arquivoAtual));
        salvaDadoNoDiscoCopia(arquivoAtual, arquivoCopia);
    }
}
